---
product: "AG Grid"
title: "Legacy Themes: Custom Icons"
description: "This section details how to provide your own icons for the grid and style grid icons for your application requirements"
framework: javascript
version: "36.2.0"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Legacy Themes: Custom Icons

This section details how to provide your own icons for the grid and style grid icons for your application requirements

> **Note**
>
> This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the [new theming docs](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/custom-icons/) or check out the [migration guide](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-migration/).

## Swapping the Provided Icon Fonts

Each provided theme comes with its own icon font. It is simple to use one provided theme with another theme's icons. Set `--ag-icon-font-family` to one of: `agGridQuartz`, `agGridAlpine`, `agGridBalham` or `agGridMaterial`. You can compare the available icon fonts in the [Provided Icons list](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-v32-custom-icons/#provided-icons).

If you are using the Sass API, it will embed the required font data for you. Apps using CSS should load the font's CSS file from whatever location they are loading `ag-grid.css` and other CSS files. For example to use the Material icons in the Quartz theme:

1. Load `agGridMaterialFont.css`
2. (optional) switch `ag-theme-quartz.css` for `ag-theme-quartz-no-font.css` to save a few kB if you no longer require the Quartz icons
3. Set the CSS variable `--ag-icon-font-family: agGridMaterial`

This example uses the Quartz theme with icons from the Material theme:

#### Swapping the Icon Font

```ts
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete", minWidth: 170 },
  { field: "age" },
  { field: "country" },
  { field: "year" },
  { field: "date" },
  { field: "sport" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
  { field: "total" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  theme: "legacy",
  columnDefs: columnDefs,
  defaultColDef: {
    editable: true,
    filter: true,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  },
  sideBar: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Swapping the Icon Font](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-swapping-font/typescript/)

## Using Alternative Icons

Grid icons can use an icon font or images. The grid exposes a number of CSS variables to control the icons. Each variable can optionally be suffixed with the name of a specific icon, and will affect only that icon, e.g. setting `--ag-icon-font-color-loading` sets the color of the "loading" icon.

Icon font variables:

- `--ag-icon-font-family[-icon-name]` set the icon font family.
- `--ag-icon-font-code[-icon-name]` set the unicode character of the icon within the icon font, using a unicode escape sequence like `"\f247"`.
- `--ag-icon-font-weight[-icon-name]` sets the font weight, used for icon fonts that require a specific weight to work.
- `--ag-icon-font-color[-icon-name]` set the color of the icon.
- `--ag-icon-font-display[-icon-name]` set this to `none` to hide the icon font if you want to provide an image-based icon instead.

Icon image variables:

- `--ag-icon-image[-icon-name]` set this to `url(/path/to/icon.svg)`
- `--ag-icon-image-opacity[-icon-name]` set the opacity of an icon. Defaults to 0.9 if not set.
- `--ag-icon-image-display[-icon-name]` set this to `none` to hide the icon image if you want to provide an font-based icon instead.

Other icon variables:

- `--ag-icon-size` sets the height and width of icons in pixels.

### Example: using an alternative icon font

This example demonstrates globally changing the icon font, and also selectively replacing individual icons:

```css
.ag-theme-quartz {
  /* replace all icons in the grid with icons from Font Awesome */
  --ag-icon-font-family: "Font Awesome 5 Free";
  --ag-icon-font-code-aggregation: "\f247";
  --ag-icon-font-code-arrows: "\f0b2";
  --ag-icon-font-code-asc: "\f062";
  /* ... and so on - because --ag-icon-font-family sets the font for
     all icons, a new code must be provided for every one. If you only
     wanted to replace some icons, use --ag-icon-font-family-{icon-name} */

  /* selectively replace the group icon with one from Material Design Icons */
  --ag-icon-font-family-group: "Material Design Icons";
  --ag-icon-font-code-group: "\F0328";
  --ag-icon-font-color-group: red;
  --ag-icon-font-weight-group: normal;
}
```

#### Alternative Icon Font

```ts
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import "ag-grid-community/styles/agGridMaterialFont.css";
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete", minWidth: 170 },
  { field: "age" },
  { field: "country" },
  { field: "year" },
  { field: "date" },
  { field: "sport" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
  { field: "total" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  theme: "legacy",
  columnDefs: columnDefs,
  defaultColDef: {
    editable: true,
    filter: true,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  },
  sideBar: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Alternative Icon Font](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-alternative-font/typescript/)

### Example: SVG icons

This example demonstrates using the `--ag-icon-image-icon-name` variables to set SVG images for specific icons.

```css
.ag-theme-quartz {
  /* hide all font icons */
  --ag-icon-font-display: none;
  /* provide a SVG icon */
  --ag-icon-image-aggregation: url("https://www.ag-grid.com/example-assets/svg-icons/aggregation.svg");
  --ag-icon-image-arrows: url("https://www.ag-grid.com/example-assets/svg-icons/arrows.svg");
  --ag-icon-image-asc: url("https://www.ag-grid.com/example-assets/svg-icons/asc.svg");
  /* ... and so on - because --ag-icon-font-display: none; hides all
     icons, an image must be provided for every one. If you only wanted
     to replace some icons, use --ag-icon-font-display-{icon-name} */
}
```

The following example replaces the grid's icons with SVG images:

#### SVG Icons

```ts
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  IntegratedChartsModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  IntegratedChartsModule.with(AgChartsEnterpriseModule),
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete", minWidth: 170 },
  { field: "age" },
  { field: "country" },
  { field: "year" },
  { field: "date" },
  { field: "sport" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
  { field: "total" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  theme: "legacy",
  columnDefs: columnDefs,
  defaultColDef: {
    editable: true,
    filter: true,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  },
  sideBar: true,
  enableCharts: true,
  cellSelection: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: SVG Icons](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-images/typescript/)

## Set the Icons Through gridOptions (JavaScript)

You can pass an `icons` property either on the [Grid Options](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-options/) to apply across the whole grid, or the [Column Definition](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-properties/). If both are provided, icons specified at the column level will take priority.

The `icons` property takes an object of name/value pairs where the name is one of the icon names below (note that these are different from the CSS names above) and the value is one of:

- An HTML string to be inserted in place of the usual DOM element for an icon
- A function that returns either an HTML string or a DOM node

#### Icon Grid Options

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  RowDragModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SideBarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowDragModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  PivotModule,
  SideBarModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

const myIcons = {
  sortAscending: () => {
    return "ASC";
  },
  sortDescending: () => {
    return "DESC";
  },
};

const columnDefs: ColDef[] = [
  {
    field: "athlete",
    rowGroup: true,
    hide: true,
  },
  {
    field: "age",
    width: 90,
    enableValue: true,
    icons: {
      // not very useful, but demonstrates you can just have strings
      sortAscending: "U",
      sortDescending: "D",
    },
  },
  {
    field: "country",
    width: 150,
    rowGroupIndex: 0,
    icons: {
      sortAscending: '<i class="fa fa-sort-alpha-up"/>',
      sortDescending: '<i class="fa fa-sort-alpha-down"/>',
    },
  },
  { field: "year", width: 90, enableRowGroup: true },
  { field: "date" },
  {
    field: "sport",
    width: 110,
    icons: myIcons,
  },
  { field: "gold", width: 100 },
  { field: "silver", width: 100 },
  { field: "bronze", width: 100 },
  { field: "total", width: 100 },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    width: 150,
    filter: true,
    floatingFilter: true,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  },
  columnDefs: columnDefs,
  sideBar: true,
  autoGroupColumnDef: {
    headerName: "Athlete",
    field: "athlete",
    rowDrag: true,
    // use font awesome for first col, with numbers for sort
    icons: {
      menu: '<i class="fa fa-shower"/>',
      menuAlt: '<i class="fa fa-shower"/>',
      filter: '<i class="fa fa-long-arrow-alt-up"/>',
      columns: '<i class="fa fa-snowflake"/>',
      sortAscending: '<i class="fa fa-sort-alpha-up"/>',
      sortDescending: '<i class="fa fa-sort-alpha-down"/>',
    },
    width: 300,
  },
  // override all the defaults with font awesome
  icons: {
    // use font awesome for menu icons
    menu: '<i class="fa fa-bath" style="width: 10px"/>',
    menuAlt: '<i class="fa fa-bath" style="width: 10px"/>',
    filter: '<i class="fa fa-long-arrow-alt-down"/>',
    columns: '<i class="fa fa-handshake"/>',
    sortAscending: '<i class="fa fa-long-arrow-alt-down"/>',
    sortDescending: '<i class="fa fa-long-arrow-alt-up"/>',
    // use some strings from group
    groupExpanded:
      '<img src="https://www.ag-grid.com/example-assets/group/contract.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
    groupContracted:
      '<img src="https://www.ag-grid.com/example-assets/group/expand.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
    columnMovePin: '<i class="far fa-hand-rock"/>',
    columnMoveAdd: '<i class="fa fa-plus-square"/>',
    columnMoveHide: '<i class="fa fa-times"/>',
    columnMoveMove: '<i class="fa fa-link"/>',
    columnMoveLeft: '<i class="fa fa-arrow-left"/>',
    columnMoveRight: '<i class="fa fa-arrow-right"/>',
    columnMoveGroup: '<i class="fa fa-users"/>',
    rowGroupPanel: '<i class="fa fa-university"/>',
    pivotPanel: '<i class="fa fa-magic"/>',
    valuePanel: '<i class="fa fa-magnet"/>',
    menuPin: "P", // just showing letters, no graphic
    menuValue: "V",
    menuAddRowGroup: "A",
    menuRemoveRowGroup: "R",
    clipboardCopy: ">>",
    clipboardCut: "<<",
    clipboardPaste: ">>",
    rowDrag: '<i class="fa fa-circle"/>',
    columnDrag: '<i class="fa fa-square"/>',
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Icon Grid Options](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-grid-options/typescript/)

In the following list, the name to use in the grid options is to the left, and on the right is the CSS icon name as listed in the [Provided Icons](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-v32-custom-icons/#provided-icons) table below.

```js
// header column group shown when expanded (click to contract)
columnGroupOpened: 'expanded'
// header column group shown when contracted (click to expand)
columnGroupClosed: 'contracted'
// column tool panel column group contracted (click to expand)
columnSelectClosed: 'tree-closed',
// column tool panel column group expanded (click to contract)
columnSelectOpen: 'tree-open',
// column tool panel header expand/collapse all button, shown when some children are expanded and
//     others are collapsed
columnSelectIndeterminate: 'tree-indeterminate',
// accordion open (filter tool panel group, charts group)
accordionOpen: 'tree-open',
// accordion closed (filter tool panel group, charts group)
accordionClosed: 'tree-closed',
// accordion indeterminate - shown when some children are expanded and
//     others are collapsed (filter tool panel group, charts group)
accordionIndeterminate: 'tree-indeterminate',
// shown on drag and drop image component icon while dragging column to the side of the grid to pin
columnMovePin: 'pin'
// shown on drag and drop image component icon while dragging over part of the page that is not a drop zone
columnMoveHide: 'eye-slash'
// shown on drag and drop image component icon while dragging columns to reorder
columnMoveMove: 'arrows'
// animating icon shown when dragging a column to the right of the grid causes horizontal scrolling
columnMoveLeft: 'left'
// animating icon shown when dragging a column to the left of the grid causes horizontal scrolling
columnMoveRight: 'right'
// shown on drag and drop image component icon while dragging over Row Groups drop zone
columnMoveGroup: 'group'
// shown on drag and drop image component icon while dragging over Values drop zone
columnMoveValue: 'aggregation'
// shown on drag and drop image component icon while dragging over pivot drop zone
columnMovePivot: 'pivot'
// shown on drag and drop image component icon while dragging over drop zone that doesn't support it, e.g.
//     string column over aggregation drop zone
dropNotAllowed: 'not-allowed'
// shown on row group when contracted (click to expand)
groupContracted: 'tree-closed'
// shown on row group when expanded (click to contract)
groupExpanded: 'tree-open'
// set filter tree list group contracted (click to expand)
setFilterGroupClosed: 'tree-closed',
// set filter tree list group expanded (click to contract)
setFilterGroupOpen: 'tree-open',
// set filter tree list expand/collapse all button, shown when some children are expanded and
//     others are collapsed
setFilterGroupIndeterminate: 'tree-indeterminate',
// set filter async values loading
setFilterLoading: 'loading'
// context menu chart item
chart: 'chart'
// dialog title bar
close: 'cross'
// X (remove) on column 'pill' after adding it to a drop zone list
cancel: 'cancel'
// indicates the currently active pin state in the "Pin column" sub-menu of the column menu
check: 'tick'
// "go to first" button in pagination controls
first: 'first'
// "go to previous" button in pagination controls
previous: 'previous'
// "go to next" button in pagination controls
next: 'next'
// "go to last" button in pagination controls
last: 'last'
// shown on top right of chart when chart is linked to range data (click to unlink)
linked: 'linked'
// shown on top right of chart when chart is not linked to range data (click to link)
unlinked: 'unlinked'
// rotating spinner shown by the loading cell renderer
groupLoading: 'loading'
// button to launch legacy column menu
menu: 'menu',
// button to launch new enterprise column menu
menuAlt: 'menu-alt',
// menu tab icon in legacy tabbed enterprise column menu
legacyMenu: 'menu'
// open filter button - header, floating filter, menu
filter: 'filter',
// filter is applied - header (legacy column menu), filter tool panel
filterActive: 'filter'
// filter tab icon in legacy tabbed enterprise column menu
filterTab: 'filter',
// filter tool panel tab
filtersToolPanel: 'filter'
// columns in menu (column chooser / columns tab)
columns: 'columns'
// column tool panel tab
columnsToolPanel: 'columns'
// "Add Calculated Column" item in column header menu
calculatedColumnAdd: 'plus'
// "Edit Calculated Column" item in column header menu
calculatedColumnEdit: 'edit'
// "Remove Calculated Column" item in menus
calculatedColumnRemove: 'minus'
// "Edit Column Name" item in menus
columnHeaderEdit: 'edit'
// button in chart regular size window title bar (click to maximise)
maximize: 'maximize'
// button in chart maximised window title bar (click to make regular size)
minimize: 'minimize'
// "Pin column" item in column header menu
menuPin: 'pin'
// "Value aggregation" column menu item (shown on numeric columns when grouping is active)"
menuValue: 'aggregation'
// "Group by {column-name}" item in column header menu
menuAddRowGroup: 'group'
// "Un-Group by {column-name}" item in column header menu
menuRemoveRowGroup: 'group'
// context menu copy item
clipboardCopy: 'copy'
// context menu cut item
clipboardCut: 'cut'
// context menu paste item
clipboardPaste: 'paste'
// identifies the pivot drop zone
pivotPanel: 'pivot'
// "Row groups" drop zone in column tool panel
rowGroupPanel: 'group'
// columns tool panel Values drop zone
valuePanel: 'aggregation'
// drag handle used to pick up draggable columns
columnDrag: 'grip'
// drag handle used to pick up draggable rows
rowDrag: 'grip'
// context menu export item
save: 'save'
// csv export
csvExport: 'csv'
// excel export
excelExport: 'excel'
// icon on select dropdowns (select cell editor, charts tool panels)
selectOpen: 'small-down',
// open icon for rich select editor
richSelectOpen: 'small-down',
// remove for rich select editor pills
richSelectRemove: 'cancel',
// icon for sub menu item
subMenuOpen: 'small-right',
// version of subMenuOpen used in RTL mode
subMenuOpenRtl: 'small-left',
// separator between column 'pills' when you add multiple columns to the header drop zone
panelDelimiter: 'small-right',
// version of panelDelimiter used in RTL mode
panelDelimiterRtl: 'small-left',
// show on column header when column is sorted ascending
sortAscending: 'asc'
// show on column header when column is sorted descending
sortDescending: 'desc'
// show on column header when column has no sort, only when enabled with colDef.unSortIcon=true
sortUnSort: 'none',
// Builder button in Advanced Filter
advancedFilterBuilder: 'group',
// drag handle used to pick up Advanced Filter Builder rows
advancedFilterBuilderDrag: 'grip',
// Advanced Filter Builder row validation error
advancedFilterBuilderInvalid: 'not-allowed',
// shown on Advanced Filter Builder rows to move them up
advancedFilterBuilderMoveUp: 'up',
// shown on Advanced Filter Builder rows to move them down
advancedFilterBuilderMoveDown: 'down',
// shown on Advanced Filter Builder rows to add new rows
advancedFilterBuilderAdd: 'plus',
// shown on Advanced Filter Builder rows to remove row
advancedFilterBuilderRemove: 'minus',
// shown on Advanced Filter Builder selection pills
advancedFilterBuilderSelect: 'small-down',
// icon to open charts menu
chartsMenu: 'menu-alt',
// Edit Chart menu item shown in Integrated Charts menu
chartsMenuEdit: 'chart',
// Advanced Settings menu item shown in Integrated Charts menu
chartsMenuAdvancedSettings: 'settings',
// shown in Integrated Charts menu add fields
chartsMenuAdd: 'plus',
// shown in Integrated Charts tool panel color picker
chartsColorPicker: 'small-down'
// previous in Integrated Charts settings tool panel theme switcher
chartsThemePrevious: 'previous',
// next in Integrated Charts settings tool panel theme switcher
chartsThemeNext: 'next',
// download chart
chartsDownload: 'save',
```

## Provided Icons

Below you can see a list with all available icons for each provided theme. The name next to each icon is the CSS name, e.g. the `pin` icon will have the CSS class `ag-icon-pin` and uses the CSS variable `--ag-icon-font-code-pin`.

Available icons: `aggregation`, `arrows`, `asc`, `aasc`, `adesc`, `cancel`, `chart`, `chevron-up`, `chevron-down`, `chevron-left`, `chevron-right`, `color-picker`, `columns`, `contracted`, `copy`, `cut`, `cross`, `csv`, `desc`, `document`, `down`, `edit`, `excel`, `expanded`, `eye-slash`, `eye`, `filter`, `filter-add`, `first`, `fx`, `grip`, `group`, `last`, `left`, `linked`, `loading`, `maximize`, `menu`, `menu-alt`, `minimize`, `minus`, `next`, `none`, `not-allowed`, `paste`, `pin`, `pinned-bottom`, `pinned-top`, `pivot`, `plus`, `previous`, `right`, `save`, `search`, `small-down`, `small-left`, `small-right`, `small-up`, `tick`, `tree-closed`, `tree-indeterminate`, `tree-open`, `unlinked`, `up`, `values-as`

Download icon sets: [Quartz](https://www.ag-grid.com/archive/36.2.0/theme-icons/quartz/quartz-icons.zip), [Balham](https://www.ag-grid.com/archive/36.2.0/theme-icons/balham/balham-icons.zip), [Material](https://www.ag-grid.com/archive/36.2.0/theme-icons/material/material-icons.zip), [Alpine](https://www.ag-grid.com/archive/36.2.0/theme-icons/alpine/alpine-icons.zip)


---
product: "AG Grid"
title: "Legacy Themes: Custom Icons"
description: "This section details how to provide your own icons for the grid and style grid icons for your application requirements"
framework: vue
version: "36.2.0"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Legacy Themes: Custom Icons

This section details how to provide your own icons for the grid and style grid icons for your application requirements

> **Note**
>
> This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the [new theming docs](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/custom-icons/) or check out the [migration guide](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-migration/).

## Swapping the Provided Icon Fonts

Each provided theme comes with its own icon font. It is simple to use one provided theme with another theme's icons. Set `--ag-icon-font-family` to one of: `agGridQuartz`, `agGridAlpine`, `agGridBalham` or `agGridMaterial`. You can compare the available icon fonts in the [Provided Icons list](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-v32-custom-icons/#provided-icons).

If you are using the Sass API, it will embed the required font data for you. Apps using CSS should load the font's CSS file from whatever location they are loading `ag-grid.css` and other CSS files. For example to use the Material icons in the Quartz theme:

1. Load `agGridMaterialFont.css`
2. (optional) switch `ag-theme-quartz.css` for `ag-theme-quartz-no-font.css` to save a few kB if you no longer require the Quartz icons
3. Set the CSS variable `--ag-icon-font-family: agGridMaterial`

This example uses the Quartz theme with icons from the Material theme:

#### Swapping the Icon Font

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  Theme,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      class="ag-theme-quartz"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :theme="theme"
      :defaultColDef="defaultColDef"
      :sideBar="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 170 },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const theme = ref<Theme | "legacy">("legacy");
    const defaultColDef = ref<ColDef>({
      editable: true,
      filter: true,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      theme,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Swapping the Icon Font](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-swapping-font/vue3/)

## Using Alternative Icons

Grid icons can use an icon font or images. The grid exposes a number of CSS variables to control the icons. Each variable can optionally be suffixed with the name of a specific icon, and will affect only that icon, e.g. setting `--ag-icon-font-color-loading` sets the color of the "loading" icon.

Icon font variables:

- `--ag-icon-font-family[-icon-name]` set the icon font family.
- `--ag-icon-font-code[-icon-name]` set the unicode character of the icon within the icon font, using a unicode escape sequence like `"\f247"`.
- `--ag-icon-font-weight[-icon-name]` sets the font weight, used for icon fonts that require a specific weight to work.
- `--ag-icon-font-color[-icon-name]` set the color of the icon.
- `--ag-icon-font-display[-icon-name]` set this to `none` to hide the icon font if you want to provide an image-based icon instead.

Icon image variables:

- `--ag-icon-image[-icon-name]` set this to `url(/path/to/icon.svg)`
- `--ag-icon-image-opacity[-icon-name]` set the opacity of an icon. Defaults to 0.9 if not set.
- `--ag-icon-image-display[-icon-name]` set this to `none` to hide the icon image if you want to provide an font-based icon instead.

Other icon variables:

- `--ag-icon-size` sets the height and width of icons in pixels.

### Example: using an alternative icon font

This example demonstrates globally changing the icon font, and also selectively replacing individual icons:

```css
.ag-theme-quartz {
  /* replace all icons in the grid with icons from Font Awesome */
  --ag-icon-font-family: "Font Awesome 5 Free";
  --ag-icon-font-code-aggregation: "\f247";
  --ag-icon-font-code-arrows: "\f0b2";
  --ag-icon-font-code-asc: "\f062";
  /* ... and so on - because --ag-icon-font-family sets the font for
     all icons, a new code must be provided for every one. If you only
     wanted to replace some icons, use --ag-icon-font-family-{icon-name} */

  /* selectively replace the group icon with one from Material Design Icons */
  --ag-icon-font-family-group: "Material Design Icons";
  --ag-icon-font-code-group: "\F0328";
  --ag-icon-font-color-group: red;
  --ag-icon-font-weight-group: normal;
}
```

#### Alternative Icon Font

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import "ag-grid-community/styles/agGridMaterialFont.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  Theme,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      class="ag-theme-quartz"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :theme="theme"
      :defaultColDef="defaultColDef"
      :sideBar="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 170 },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const theme = ref<Theme | "legacy">("legacy");
    const defaultColDef = ref<ColDef>({
      editable: true,
      filter: true,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      theme,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Alternative Icon Font](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-alternative-font/vue3/)

### Example: SVG icons

This example demonstrates using the `--ag-icon-image-icon-name` variables to set SVG images for specific icons.

```css
.ag-theme-quartz {
  /* hide all font icons */
  --ag-icon-font-display: none;
  /* provide a SVG icon */
  --ag-icon-image-aggregation: url("https://www.ag-grid.com/example-assets/svg-icons/aggregation.svg");
  --ag-icon-image-arrows: url("https://www.ag-grid.com/example-assets/svg-icons/arrows.svg");
  --ag-icon-image-asc: url("https://www.ag-grid.com/example-assets/svg-icons/asc.svg");
  /* ... and so on - because --ag-icon-font-display: none; hides all
     icons, an image must be provided for every one. If you only wanted
     to replace some icons, use --ag-icon-font-display-{icon-name} */
}
```

The following example replaces the grid's icons with SVG images:

#### SVG Icons

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  Theme,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  IntegratedChartsModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  IntegratedChartsModule.with(AgChartsEnterpriseModule),
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      class="ag-theme-quartz"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :theme="theme"
      :defaultColDef="defaultColDef"
      :sideBar="true"
      :enableCharts="true"
      :cellSelection="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 170 },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const theme = ref<Theme | "legacy">("legacy");
    const defaultColDef = ref<ColDef>({
      editable: true,
      filter: true,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      theme,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: SVG Icons](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-images/vue3/)

## Set the Icons Through gridOptions (JavaScript)

You can pass an `icons` property either on the [Grid Options](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-options/) to apply across the whole grid, or the [Column Definition](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-properties/). If both are provided, icons specified at the column level will take priority.

The `icons` property takes an object of name/value pairs where the name is one of the icon names below (note that these are different from the CSS names above) and the value is one of:

- An HTML string to be inserted in place of the usual DOM element for an icon
- A function that returns either an HTML string or a DOM node

#### Icon Grid Options

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  Icons,
  ModuleRegistry,
  NumberFilterModule,
  RowDragModule,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SideBarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowDragModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  PivotModule,
  SideBarModule,
  ColumnMenuModule,
  ContextMenuModule,
]);

const myIcons = {
  sortAscending: () => {
    return "ASC";
  },
  sortDescending: () => {
    return "DESC";
  },
};

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :sideBar="true"
      :autoGroupColumnDef="autoGroupColumnDef"
      :icons="icons"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "athlete",
        rowGroup: true,
        hide: true,
      },
      {
        field: "age",
        width: 90,
        enableValue: true,
        icons: {
          // not very useful, but demonstrates you can just have strings
          sortAscending: "U",
          sortDescending: "D",
        },
      },
      {
        field: "country",
        width: 150,
        rowGroupIndex: 0,
        icons: {
          sortAscending: '<i class="fa fa-sort-alpha-up"/>',
          sortDescending: '<i class="fa fa-sort-alpha-down"/>',
        },
      },
      { field: "year", width: 90, enableRowGroup: true },
      { field: "date" },
      {
        field: "sport",
        width: 110,
        icons: myIcons,
      },
      { field: "gold", width: 100 },
      { field: "silver", width: 100 },
      { field: "bronze", width: 100 },
      { field: "total", width: 100 },
    ]);
    const defaultColDef = ref<ColDef>({
      width: 150,
      filter: true,
      floatingFilter: true,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      headerName: "Athlete",
      field: "athlete",
      rowDrag: true,
      // use font awesome for first col, with numbers for sort
      icons: {
        menu: '<i class="fa fa-shower"/>',
        menuAlt: '<i class="fa fa-shower"/>',
        filter: '<i class="fa fa-long-arrow-alt-up"/>',
        columns: '<i class="fa fa-snowflake"/>',
        sortAscending: '<i class="fa fa-sort-alpha-up"/>',
        sortDescending: '<i class="fa fa-sort-alpha-down"/>',
      },
      width: 300,
    });
    const icons = ref<Icons>({
      // use font awesome for menu icons
      menu: '<i class="fa fa-bath" style="width: 10px"/>',
      menuAlt: '<i class="fa fa-bath" style="width: 10px"/>',
      filter: '<i class="fa fa-long-arrow-alt-down"/>',
      columns: '<i class="fa fa-handshake"/>',
      sortAscending: '<i class="fa fa-long-arrow-alt-down"/>',
      sortDescending: '<i class="fa fa-long-arrow-alt-up"/>',
      // use some strings from group
      groupExpanded:
        '<img src="https://www.ag-grid.com/example-assets/group/contract.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
      groupContracted:
        '<img src="https://www.ag-grid.com/example-assets/group/expand.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
      columnMovePin: '<i class="far fa-hand-rock"/>',
      columnMoveAdd: '<i class="fa fa-plus-square"/>',
      columnMoveHide: '<i class="fa fa-times"/>',
      columnMoveMove: '<i class="fa fa-link"/>',
      columnMoveLeft: '<i class="fa fa-arrow-left"/>',
      columnMoveRight: '<i class="fa fa-arrow-right"/>',
      columnMoveGroup: '<i class="fa fa-users"/>',
      rowGroupPanel: '<i class="fa fa-university"/>',
      pivotPanel: '<i class="fa fa-magic"/>',
      valuePanel: '<i class="fa fa-magnet"/>',
      menuPin: "P", // just showing letters, no graphic
      menuValue: "V",
      menuAddRowGroup: "A",
      menuRemoveRowGroup: "R",
      clipboardCopy: ">>",
      clipboardCut: "<<",
      clipboardPaste: ">>",
      rowDrag: '<i class="fa fa-circle"/>',
      columnDrag: '<i class="fa fa-square"/>',
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      icons,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Icon Grid Options](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-grid-options/vue3/)

In the following list, the name to use in the grid options is to the left, and on the right is the CSS icon name as listed in the [Provided Icons](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-v32-custom-icons/#provided-icons) table below.

```js
// header column group shown when expanded (click to contract)
columnGroupOpened: 'expanded'
// header column group shown when contracted (click to expand)
columnGroupClosed: 'contracted'
// column tool panel column group contracted (click to expand)
columnSelectClosed: 'tree-closed',
// column tool panel column group expanded (click to contract)
columnSelectOpen: 'tree-open',
// column tool panel header expand/collapse all button, shown when some children are expanded and
//     others are collapsed
columnSelectIndeterminate: 'tree-indeterminate',
// accordion open (filter tool panel group, charts group)
accordionOpen: 'tree-open',
// accordion closed (filter tool panel group, charts group)
accordionClosed: 'tree-closed',
// accordion indeterminate - shown when some children are expanded and
//     others are collapsed (filter tool panel group, charts group)
accordionIndeterminate: 'tree-indeterminate',
// shown on drag and drop image component icon while dragging column to the side of the grid to pin
columnMovePin: 'pin'
// shown on drag and drop image component icon while dragging over part of the page that is not a drop zone
columnMoveHide: 'eye-slash'
// shown on drag and drop image component icon while dragging columns to reorder
columnMoveMove: 'arrows'
// animating icon shown when dragging a column to the right of the grid causes horizontal scrolling
columnMoveLeft: 'left'
// animating icon shown when dragging a column to the left of the grid causes horizontal scrolling
columnMoveRight: 'right'
// shown on drag and drop image component icon while dragging over Row Groups drop zone
columnMoveGroup: 'group'
// shown on drag and drop image component icon while dragging over Values drop zone
columnMoveValue: 'aggregation'
// shown on drag and drop image component icon while dragging over pivot drop zone
columnMovePivot: 'pivot'
// shown on drag and drop image component icon while dragging over drop zone that doesn't support it, e.g.
//     string column over aggregation drop zone
dropNotAllowed: 'not-allowed'
// shown on row group when contracted (click to expand)
groupContracted: 'tree-closed'
// shown on row group when expanded (click to contract)
groupExpanded: 'tree-open'
// set filter tree list group contracted (click to expand)
setFilterGroupClosed: 'tree-closed',
// set filter tree list group expanded (click to contract)
setFilterGroupOpen: 'tree-open',
// set filter tree list expand/collapse all button, shown when some children are expanded and
//     others are collapsed
setFilterGroupIndeterminate: 'tree-indeterminate',
// set filter async values loading
setFilterLoading: 'loading'
// context menu chart item
chart: 'chart'
// dialog title bar
close: 'cross'
// X (remove) on column 'pill' after adding it to a drop zone list
cancel: 'cancel'
// indicates the currently active pin state in the "Pin column" sub-menu of the column menu
check: 'tick'
// "go to first" button in pagination controls
first: 'first'
// "go to previous" button in pagination controls
previous: 'previous'
// "go to next" button in pagination controls
next: 'next'
// "go to last" button in pagination controls
last: 'last'
// shown on top right of chart when chart is linked to range data (click to unlink)
linked: 'linked'
// shown on top right of chart when chart is not linked to range data (click to link)
unlinked: 'unlinked'
// rotating spinner shown by the loading cell renderer
groupLoading: 'loading'
// button to launch legacy column menu
menu: 'menu',
// button to launch new enterprise column menu
menuAlt: 'menu-alt',
// menu tab icon in legacy tabbed enterprise column menu
legacyMenu: 'menu'
// open filter button - header, floating filter, menu
filter: 'filter',
// filter is applied - header (legacy column menu), filter tool panel
filterActive: 'filter'
// filter tab icon in legacy tabbed enterprise column menu
filterTab: 'filter',
// filter tool panel tab
filtersToolPanel: 'filter'
// columns in menu (column chooser / columns tab)
columns: 'columns'
// column tool panel tab
columnsToolPanel: 'columns'
// "Add Calculated Column" item in column header menu
calculatedColumnAdd: 'plus'
// "Edit Calculated Column" item in column header menu
calculatedColumnEdit: 'edit'
// "Remove Calculated Column" item in menus
calculatedColumnRemove: 'minus'
// "Edit Column Name" item in menus
columnHeaderEdit: 'edit'
// button in chart regular size window title bar (click to maximise)
maximize: 'maximize'
// button in chart maximised window title bar (click to make regular size)
minimize: 'minimize'
// "Pin column" item in column header menu
menuPin: 'pin'
// "Value aggregation" column menu item (shown on numeric columns when grouping is active)"
menuValue: 'aggregation'
// "Group by {column-name}" item in column header menu
menuAddRowGroup: 'group'
// "Un-Group by {column-name}" item in column header menu
menuRemoveRowGroup: 'group'
// context menu copy item
clipboardCopy: 'copy'
// context menu cut item
clipboardCut: 'cut'
// context menu paste item
clipboardPaste: 'paste'
// identifies the pivot drop zone
pivotPanel: 'pivot'
// "Row groups" drop zone in column tool panel
rowGroupPanel: 'group'
// columns tool panel Values drop zone
valuePanel: 'aggregation'
// drag handle used to pick up draggable columns
columnDrag: 'grip'
// drag handle used to pick up draggable rows
rowDrag: 'grip'
// context menu export item
save: 'save'
// csv export
csvExport: 'csv'
// excel export
excelExport: 'excel'
// icon on select dropdowns (select cell editor, charts tool panels)
selectOpen: 'small-down',
// open icon for rich select editor
richSelectOpen: 'small-down',
// remove for rich select editor pills
richSelectRemove: 'cancel',
// icon for sub menu item
subMenuOpen: 'small-right',
// version of subMenuOpen used in RTL mode
subMenuOpenRtl: 'small-left',
// separator between column 'pills' when you add multiple columns to the header drop zone
panelDelimiter: 'small-right',
// version of panelDelimiter used in RTL mode
panelDelimiterRtl: 'small-left',
// show on column header when column is sorted ascending
sortAscending: 'asc'
// show on column header when column is sorted descending
sortDescending: 'desc'
// show on column header when column has no sort, only when enabled with colDef.unSortIcon=true
sortUnSort: 'none',
// Builder button in Advanced Filter
advancedFilterBuilder: 'group',
// drag handle used to pick up Advanced Filter Builder rows
advancedFilterBuilderDrag: 'grip',
// Advanced Filter Builder row validation error
advancedFilterBuilderInvalid: 'not-allowed',
// shown on Advanced Filter Builder rows to move them up
advancedFilterBuilderMoveUp: 'up',
// shown on Advanced Filter Builder rows to move them down
advancedFilterBuilderMoveDown: 'down',
// shown on Advanced Filter Builder rows to add new rows
advancedFilterBuilderAdd: 'plus',
// shown on Advanced Filter Builder rows to remove row
advancedFilterBuilderRemove: 'minus',
// shown on Advanced Filter Builder selection pills
advancedFilterBuilderSelect: 'small-down',
// icon to open charts menu
chartsMenu: 'menu-alt',
// Edit Chart menu item shown in Integrated Charts menu
chartsMenuEdit: 'chart',
// Advanced Settings menu item shown in Integrated Charts menu
chartsMenuAdvancedSettings: 'settings',
// shown in Integrated Charts menu add fields
chartsMenuAdd: 'plus',
// shown in Integrated Charts tool panel color picker
chartsColorPicker: 'small-down'
// previous in Integrated Charts settings tool panel theme switcher
chartsThemePrevious: 'previous',
// next in Integrated Charts settings tool panel theme switcher
chartsThemeNext: 'next',
// download chart
chartsDownload: 'save',
```

## Provided Icons

Below you can see a list with all available icons for each provided theme. The name next to each icon is the CSS name, e.g. the `pin` icon will have the CSS class `ag-icon-pin` and uses the CSS variable `--ag-icon-font-code-pin`.

Available icons: `aggregation`, `arrows`, `asc`, `aasc`, `adesc`, `cancel`, `chart`, `chevron-up`, `chevron-down`, `chevron-left`, `chevron-right`, `color-picker`, `columns`, `contracted`, `copy`, `cut`, `cross`, `csv`, `desc`, `document`, `down`, `edit`, `excel`, `expanded`, `eye-slash`, `eye`, `filter`, `filter-add`, `first`, `fx`, `grip`, `group`, `last`, `left`, `linked`, `loading`, `maximize`, `menu`, `menu-alt`, `minimize`, `minus`, `next`, `none`, `not-allowed`, `paste`, `pin`, `pinned-bottom`, `pinned-top`, `pivot`, `plus`, `previous`, `right`, `save`, `search`, `small-down`, `small-left`, `small-right`, `small-up`, `tick`, `tree-closed`, `tree-indeterminate`, `tree-open`, `unlinked`, `up`, `values-as`

Download icon sets: [Quartz](https://www.ag-grid.com/archive/36.2.0/theme-icons/quartz/quartz-icons.zip), [Balham](https://www.ag-grid.com/archive/36.2.0/theme-icons/balham/balham-icons.zip), [Material](https://www.ag-grid.com/archive/36.2.0/theme-icons/material/material-icons.zip), [Alpine](https://www.ag-grid.com/archive/36.2.0/theme-icons/alpine/alpine-icons.zip)


---
product: "AG Grid"
title: "Legacy Themes: Custom Icons"
description: "This section details how to provide your own icons for the grid and style grid icons for your application requirements"
framework: angular
version: "36.2.0"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Legacy Themes: Custom Icons

This section details how to provide your own icons for the grid and style grid icons for your application requirements

> **Note**
>
> This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the [new theming docs](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/custom-icons/) or check out the [migration guide](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-migration/).

## Swapping the Provided Icon Fonts

Each provided theme comes with its own icon font. It is simple to use one provided theme with another theme's icons. Set `--ag-icon-font-family` to one of: `agGridQuartz`, `agGridAlpine`, `agGridBalham` or `agGridMaterial`. You can compare the available icon fonts in the [Provided Icons list](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-v32-custom-icons/#provided-icons).

If you are using the Sass API, it will embed the required font data for you. Apps using CSS should load the font's CSS file from whatever location they are loading `ag-grid.css` and other CSS files. For example to use the Material icons in the Quartz theme:

1. Load `agGridMaterialFont.css`
2. (optional) switch `ag-theme-quartz.css` for `ag-theme-quartz-no-font.css` to save a few kB if you no longer require the Quartz icons
3. Set the CSS variable `--ag-icon-font-family: agGridMaterial`

This example uses the Quartz theme with icons from the Material theme:

#### Swapping the Icon Font

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  Theme,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    class="ag-theme-quartz"
    [columnDefs]="columnDefs"
    [theme]="theme"
    [defaultColDef]="defaultColDef"
    [sideBar]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 170 },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  theme: Theme | "legacy" = "legacy";
  defaultColDef: ColDef = {
    editable: true,
    filter: true,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Swapping the Icon Font](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-swapping-font/angular/)

## Using Alternative Icons

Grid icons can use an icon font or images. The grid exposes a number of CSS variables to control the icons. Each variable can optionally be suffixed with the name of a specific icon, and will affect only that icon, e.g. setting `--ag-icon-font-color-loading` sets the color of the "loading" icon.

Icon font variables:

- `--ag-icon-font-family[-icon-name]` set the icon font family.
- `--ag-icon-font-code[-icon-name]` set the unicode character of the icon within the icon font, using a unicode escape sequence like `"\f247"`.
- `--ag-icon-font-weight[-icon-name]` sets the font weight, used for icon fonts that require a specific weight to work.
- `--ag-icon-font-color[-icon-name]` set the color of the icon.
- `--ag-icon-font-display[-icon-name]` set this to `none` to hide the icon font if you want to provide an image-based icon instead.

Icon image variables:

- `--ag-icon-image[-icon-name]` set this to `url(/path/to/icon.svg)`
- `--ag-icon-image-opacity[-icon-name]` set the opacity of an icon. Defaults to 0.9 if not set.
- `--ag-icon-image-display[-icon-name]` set this to `none` to hide the icon image if you want to provide an font-based icon instead.

Other icon variables:

- `--ag-icon-size` sets the height and width of icons in pixels.

### Example: using an alternative icon font

This example demonstrates globally changing the icon font, and also selectively replacing individual icons:

```css
.ag-theme-quartz {
  /* replace all icons in the grid with icons from Font Awesome */
  --ag-icon-font-family: "Font Awesome 5 Free";
  --ag-icon-font-code-aggregation: "\f247";
  --ag-icon-font-code-arrows: "\f0b2";
  --ag-icon-font-code-asc: "\f062";
  /* ... and so on - because --ag-icon-font-family sets the font for
     all icons, a new code must be provided for every one. If you only
     wanted to replace some icons, use --ag-icon-font-family-{icon-name} */

  /* selectively replace the group icon with one from Material Design Icons */
  --ag-icon-font-family-group: "Material Design Icons";
  --ag-icon-font-code-group: "\F0328";
  --ag-icon-font-color-group: red;
  --ag-icon-font-weight-group: normal;
}
```

#### Alternative Icon Font

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import "ag-grid-community/styles/agGridMaterialFont.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  Theme,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    class="ag-theme-quartz"
    [columnDefs]="columnDefs"
    [theme]="theme"
    [defaultColDef]="defaultColDef"
    [sideBar]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 170 },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  theme: Theme | "legacy" = "legacy";
  defaultColDef: ColDef = {
    editable: true,
    filter: true,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Alternative Icon Font](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-alternative-font/angular/)

### Example: SVG icons

This example demonstrates using the `--ag-icon-image-icon-name` variables to set SVG images for specific icons.

```css
.ag-theme-quartz {
  /* hide all font icons */
  --ag-icon-font-display: none;
  /* provide a SVG icon */
  --ag-icon-image-aggregation: url("https://www.ag-grid.com/example-assets/svg-icons/aggregation.svg");
  --ag-icon-image-arrows: url("https://www.ag-grid.com/example-assets/svg-icons/arrows.svg");
  --ag-icon-image-asc: url("https://www.ag-grid.com/example-assets/svg-icons/asc.svg");
  /* ... and so on - because --ag-icon-font-display: none; hides all
     icons, an image must be provided for every one. If you only wanted
     to replace some icons, use --ag-icon-font-display-{icon-name} */
}
```

The following example replaces the grid's icons with SVG images:

#### SVG Icons

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  Theme,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  IntegratedChartsModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  IntegratedChartsModule.with(AgChartsEnterpriseModule),
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    class="ag-theme-quartz"
    [columnDefs]="columnDefs"
    [theme]="theme"
    [defaultColDef]="defaultColDef"
    [sideBar]="true"
    [enableCharts]="true"
    [cellSelection]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 170 },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  theme: Theme | "legacy" = "legacy";
  defaultColDef: ColDef = {
    editable: true,
    filter: true,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: SVG Icons](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-images/angular/)

## Set the Icons Through gridOptions (JavaScript)

You can pass an `icons` property either on the [Grid Options](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-options/) to apply across the whole grid, or the [Column Definition](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-properties/). If both are provided, icons specified at the column level will take priority.

The `icons` property takes an object of name/value pairs where the name is one of the icon names below (note that these are different from the CSS names above) and the value is one of:

- An HTML string to be inserted in place of the usual DOM element for an icon
- A function that returns either an HTML string or a DOM node

#### Icon Grid Options

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  Icons,
  ModuleRegistry,
  NumberFilterModule,
  RowDragModule,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SideBarModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowDragModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  PivotModule,
  SideBarModule,
  ColumnMenuModule,
  ContextMenuModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [sideBar]="true"
    [autoGroupColumnDef]="autoGroupColumnDef"
    [icons]="icons"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "athlete",
      rowGroup: true,
      hide: true,
    },
    {
      field: "age",
      width: 90,
      enableValue: true,
      icons: {
        // not very useful, but demonstrates you can just have strings
        sortAscending: "U",
        sortDescending: "D",
      },
    },
    {
      field: "country",
      width: 150,
      rowGroupIndex: 0,
      icons: {
        sortAscending: '<i class="fa fa-sort-alpha-up"/>',
        sortDescending: '<i class="fa fa-sort-alpha-down"/>',
      },
    },
    { field: "year", width: 90, enableRowGroup: true },
    { field: "date" },
    {
      field: "sport",
      width: 110,
      icons: myIcons,
    },
    { field: "gold", width: 100 },
    { field: "silver", width: 100 },
    { field: "bronze", width: 100 },
    { field: "total", width: 100 },
  ];
  defaultColDef: ColDef = {
    width: 150,
    filter: true,
    floatingFilter: true,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    headerName: "Athlete",
    field: "athlete",
    rowDrag: true,
    // use font awesome for first col, with numbers for sort
    icons: {
      menu: '<i class="fa fa-shower"/>',
      menuAlt: '<i class="fa fa-shower"/>',
      filter: '<i class="fa fa-long-arrow-alt-up"/>',
      columns: '<i class="fa fa-snowflake"/>',
      sortAscending: '<i class="fa fa-sort-alpha-up"/>',
      sortDescending: '<i class="fa fa-sort-alpha-down"/>',
    },
    width: 300,
  };
  icons: Icons = {
    // use font awesome for menu icons
    menu: '<i class="fa fa-bath" style="width: 10px"/>',
    menuAlt: '<i class="fa fa-bath" style="width: 10px"/>',
    filter: '<i class="fa fa-long-arrow-alt-down"/>',
    columns: '<i class="fa fa-handshake"/>',
    sortAscending: '<i class="fa fa-long-arrow-alt-down"/>',
    sortDescending: '<i class="fa fa-long-arrow-alt-up"/>',
    // use some strings from group
    groupExpanded:
      '<img src="https://www.ag-grid.com/example-assets/group/contract.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
    groupContracted:
      '<img src="https://www.ag-grid.com/example-assets/group/expand.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
    columnMovePin: '<i class="far fa-hand-rock"/>',
    columnMoveAdd: '<i class="fa fa-plus-square"/>',
    columnMoveHide: '<i class="fa fa-times"/>',
    columnMoveMove: '<i class="fa fa-link"/>',
    columnMoveLeft: '<i class="fa fa-arrow-left"/>',
    columnMoveRight: '<i class="fa fa-arrow-right"/>',
    columnMoveGroup: '<i class="fa fa-users"/>',
    rowGroupPanel: '<i class="fa fa-university"/>',
    pivotPanel: '<i class="fa fa-magic"/>',
    valuePanel: '<i class="fa fa-magnet"/>',
    menuPin: "P", // just showing letters, no graphic
    menuValue: "V",
    menuAddRowGroup: "A",
    menuRemoveRowGroup: "R",
    clipboardCopy: ">>",
    clipboardCut: "<<",
    clipboardPaste: ">>",
    rowDrag: '<i class="fa fa-circle"/>',
    columnDrag: '<i class="fa fa-square"/>',
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}

const myIcons = {
  sortAscending: () => {
    return "ASC";
  },
  sortDescending: () => {
    return "DESC";
  },
};
```

[Live example: Icon Grid Options](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-grid-options/angular/)

In the following list, the name to use in the grid options is to the left, and on the right is the CSS icon name as listed in the [Provided Icons](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-v32-custom-icons/#provided-icons) table below.

```js
// header column group shown when expanded (click to contract)
columnGroupOpened: 'expanded'
// header column group shown when contracted (click to expand)
columnGroupClosed: 'contracted'
// column tool panel column group contracted (click to expand)
columnSelectClosed: 'tree-closed',
// column tool panel column group expanded (click to contract)
columnSelectOpen: 'tree-open',
// column tool panel header expand/collapse all button, shown when some children are expanded and
//     others are collapsed
columnSelectIndeterminate: 'tree-indeterminate',
// accordion open (filter tool panel group, charts group)
accordionOpen: 'tree-open',
// accordion closed (filter tool panel group, charts group)
accordionClosed: 'tree-closed',
// accordion indeterminate - shown when some children are expanded and
//     others are collapsed (filter tool panel group, charts group)
accordionIndeterminate: 'tree-indeterminate',
// shown on drag and drop image component icon while dragging column to the side of the grid to pin
columnMovePin: 'pin'
// shown on drag and drop image component icon while dragging over part of the page that is not a drop zone
columnMoveHide: 'eye-slash'
// shown on drag and drop image component icon while dragging columns to reorder
columnMoveMove: 'arrows'
// animating icon shown when dragging a column to the right of the grid causes horizontal scrolling
columnMoveLeft: 'left'
// animating icon shown when dragging a column to the left of the grid causes horizontal scrolling
columnMoveRight: 'right'
// shown on drag and drop image component icon while dragging over Row Groups drop zone
columnMoveGroup: 'group'
// shown on drag and drop image component icon while dragging over Values drop zone
columnMoveValue: 'aggregation'
// shown on drag and drop image component icon while dragging over pivot drop zone
columnMovePivot: 'pivot'
// shown on drag and drop image component icon while dragging over drop zone that doesn't support it, e.g.
//     string column over aggregation drop zone
dropNotAllowed: 'not-allowed'
// shown on row group when contracted (click to expand)
groupContracted: 'tree-closed'
// shown on row group when expanded (click to contract)
groupExpanded: 'tree-open'
// set filter tree list group contracted (click to expand)
setFilterGroupClosed: 'tree-closed',
// set filter tree list group expanded (click to contract)
setFilterGroupOpen: 'tree-open',
// set filter tree list expand/collapse all button, shown when some children are expanded and
//     others are collapsed
setFilterGroupIndeterminate: 'tree-indeterminate',
// set filter async values loading
setFilterLoading: 'loading'
// context menu chart item
chart: 'chart'
// dialog title bar
close: 'cross'
// X (remove) on column 'pill' after adding it to a drop zone list
cancel: 'cancel'
// indicates the currently active pin state in the "Pin column" sub-menu of the column menu
check: 'tick'
// "go to first" button in pagination controls
first: 'first'
// "go to previous" button in pagination controls
previous: 'previous'
// "go to next" button in pagination controls
next: 'next'
// "go to last" button in pagination controls
last: 'last'
// shown on top right of chart when chart is linked to range data (click to unlink)
linked: 'linked'
// shown on top right of chart when chart is not linked to range data (click to link)
unlinked: 'unlinked'
// rotating spinner shown by the loading cell renderer
groupLoading: 'loading'
// button to launch legacy column menu
menu: 'menu',
// button to launch new enterprise column menu
menuAlt: 'menu-alt',
// menu tab icon in legacy tabbed enterprise column menu
legacyMenu: 'menu'
// open filter button - header, floating filter, menu
filter: 'filter',
// filter is applied - header (legacy column menu), filter tool panel
filterActive: 'filter'
// filter tab icon in legacy tabbed enterprise column menu
filterTab: 'filter',
// filter tool panel tab
filtersToolPanel: 'filter'
// columns in menu (column chooser / columns tab)
columns: 'columns'
// column tool panel tab
columnsToolPanel: 'columns'
// "Add Calculated Column" item in column header menu
calculatedColumnAdd: 'plus'
// "Edit Calculated Column" item in column header menu
calculatedColumnEdit: 'edit'
// "Remove Calculated Column" item in menus
calculatedColumnRemove: 'minus'
// "Edit Column Name" item in menus
columnHeaderEdit: 'edit'
// button in chart regular size window title bar (click to maximise)
maximize: 'maximize'
// button in chart maximised window title bar (click to make regular size)
minimize: 'minimize'
// "Pin column" item in column header menu
menuPin: 'pin'
// "Value aggregation" column menu item (shown on numeric columns when grouping is active)"
menuValue: 'aggregation'
// "Group by {column-name}" item in column header menu
menuAddRowGroup: 'group'
// "Un-Group by {column-name}" item in column header menu
menuRemoveRowGroup: 'group'
// context menu copy item
clipboardCopy: 'copy'
// context menu cut item
clipboardCut: 'cut'
// context menu paste item
clipboardPaste: 'paste'
// identifies the pivot drop zone
pivotPanel: 'pivot'
// "Row groups" drop zone in column tool panel
rowGroupPanel: 'group'
// columns tool panel Values drop zone
valuePanel: 'aggregation'
// drag handle used to pick up draggable columns
columnDrag: 'grip'
// drag handle used to pick up draggable rows
rowDrag: 'grip'
// context menu export item
save: 'save'
// csv export
csvExport: 'csv'
// excel export
excelExport: 'excel'
// icon on select dropdowns (select cell editor, charts tool panels)
selectOpen: 'small-down',
// open icon for rich select editor
richSelectOpen: 'small-down',
// remove for rich select editor pills
richSelectRemove: 'cancel',
// icon for sub menu item
subMenuOpen: 'small-right',
// version of subMenuOpen used in RTL mode
subMenuOpenRtl: 'small-left',
// separator between column 'pills' when you add multiple columns to the header drop zone
panelDelimiter: 'small-right',
// version of panelDelimiter used in RTL mode
panelDelimiterRtl: 'small-left',
// show on column header when column is sorted ascending
sortAscending: 'asc'
// show on column header when column is sorted descending
sortDescending: 'desc'
// show on column header when column has no sort, only when enabled with colDef.unSortIcon=true
sortUnSort: 'none',
// Builder button in Advanced Filter
advancedFilterBuilder: 'group',
// drag handle used to pick up Advanced Filter Builder rows
advancedFilterBuilderDrag: 'grip',
// Advanced Filter Builder row validation error
advancedFilterBuilderInvalid: 'not-allowed',
// shown on Advanced Filter Builder rows to move them up
advancedFilterBuilderMoveUp: 'up',
// shown on Advanced Filter Builder rows to move them down
advancedFilterBuilderMoveDown: 'down',
// shown on Advanced Filter Builder rows to add new rows
advancedFilterBuilderAdd: 'plus',
// shown on Advanced Filter Builder rows to remove row
advancedFilterBuilderRemove: 'minus',
// shown on Advanced Filter Builder selection pills
advancedFilterBuilderSelect: 'small-down',
// icon to open charts menu
chartsMenu: 'menu-alt',
// Edit Chart menu item shown in Integrated Charts menu
chartsMenuEdit: 'chart',
// Advanced Settings menu item shown in Integrated Charts menu
chartsMenuAdvancedSettings: 'settings',
// shown in Integrated Charts menu add fields
chartsMenuAdd: 'plus',
// shown in Integrated Charts tool panel color picker
chartsColorPicker: 'small-down'
// previous in Integrated Charts settings tool panel theme switcher
chartsThemePrevious: 'previous',
// next in Integrated Charts settings tool panel theme switcher
chartsThemeNext: 'next',
// download chart
chartsDownload: 'save',
```

## Provided Icons

Below you can see a list with all available icons for each provided theme. The name next to each icon is the CSS name, e.g. the `pin` icon will have the CSS class `ag-icon-pin` and uses the CSS variable `--ag-icon-font-code-pin`.

Available icons: `aggregation`, `arrows`, `asc`, `aasc`, `adesc`, `cancel`, `chart`, `chevron-up`, `chevron-down`, `chevron-left`, `chevron-right`, `color-picker`, `columns`, `contracted`, `copy`, `cut`, `cross`, `csv`, `desc`, `document`, `down`, `edit`, `excel`, `expanded`, `eye-slash`, `eye`, `filter`, `filter-add`, `first`, `fx`, `grip`, `group`, `last`, `left`, `linked`, `loading`, `maximize`, `menu`, `menu-alt`, `minimize`, `minus`, `next`, `none`, `not-allowed`, `paste`, `pin`, `pinned-bottom`, `pinned-top`, `pivot`, `plus`, `previous`, `right`, `save`, `search`, `small-down`, `small-left`, `small-right`, `small-up`, `tick`, `tree-closed`, `tree-indeterminate`, `tree-open`, `unlinked`, `up`, `values-as`

Download icon sets: [Quartz](https://www.ag-grid.com/archive/36.2.0/theme-icons/quartz/quartz-icons.zip), [Balham](https://www.ag-grid.com/archive/36.2.0/theme-icons/balham/balham-icons.zip), [Material](https://www.ag-grid.com/archive/36.2.0/theme-icons/material/material-icons.zip), [Alpine](https://www.ag-grid.com/archive/36.2.0/theme-icons/alpine/alpine-icons.zip)


---
product: "AG Grid"
title: "Legacy Themes: Custom Icons"
description: "This section details how to provide your own icons for the grid and style grid icons for your application requirements"
framework: react
version: "36.2.0"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Legacy Themes: Custom Icons

This section details how to provide your own icons for the grid and style grid icons for your application requirements

> **Note**
>
> This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the [new theming docs](https://www.ag-grid.com/archive/36.2.0/react-data-grid/custom-icons/) or check out the [migration guide](https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-migration/).

## Swapping the Provided Icon Fonts

Each provided theme comes with its own icon font. It is simple to use one provided theme with another theme's icons. Set `--ag-icon-font-family` to one of: `agGridQuartz`, `agGridAlpine`, `agGridBalham` or `agGridMaterial`. You can compare the available icon fonts in the [Provided Icons list](https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-v32-custom-icons/#provided-icons).

If you are using the Sass API, it will embed the required font data for you. Apps using CSS should load the font's CSS file from whatever location they are loading `ag-grid.css` and other CSS files. For example to use the Material icons in the Quartz theme:

1. Load `agGridMaterialFont.css`
2. (optional) switch `ag-theme-quartz.css` for `ag-theme-quartz-no-font.css` to save a few kB if you no longer require the Quartz icons
3. Set the CSS variable `--ag-icon-font-family: agGridMaterial`

This example uses the Quartz theme with icons from the Material theme:

#### Swapping the Icon Font

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  Theme,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 170 },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      filter: true,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle} className="ag-theme-quartz">
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            theme={"legacy"}
            defaultColDef={defaultColDef}
            sideBar={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Swapping the Icon Font](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-swapping-font/reactFunctionalTs/)

## Using Alternative Icons

Grid icons can use an icon font or images. The grid exposes a number of CSS variables to control the icons. Each variable can optionally be suffixed with the name of a specific icon, and will affect only that icon, e.g. setting `--ag-icon-font-color-loading` sets the color of the "loading" icon.

Icon font variables:

- `--ag-icon-font-family[-icon-name]` set the icon font family.
- `--ag-icon-font-code[-icon-name]` set the unicode character of the icon within the icon font, using a unicode escape sequence like `"\f247"`.
- `--ag-icon-font-weight[-icon-name]` sets the font weight, used for icon fonts that require a specific weight to work.
- `--ag-icon-font-color[-icon-name]` set the color of the icon.
- `--ag-icon-font-display[-icon-name]` set this to `none` to hide the icon font if you want to provide an image-based icon instead.

Icon image variables:

- `--ag-icon-image[-icon-name]` set this to `url(/path/to/icon.svg)`
- `--ag-icon-image-opacity[-icon-name]` set the opacity of an icon. Defaults to 0.9 if not set.
- `--ag-icon-image-display[-icon-name]` set this to `none` to hide the icon image if you want to provide an font-based icon instead.

Other icon variables:

- `--ag-icon-size` sets the height and width of icons in pixels.

### Example: using an alternative icon font

This example demonstrates globally changing the icon font, and also selectively replacing individual icons:

```css
.ag-theme-quartz {
  /* replace all icons in the grid with icons from Font Awesome */
  --ag-icon-font-family: "Font Awesome 5 Free";
  --ag-icon-font-code-aggregation: "\f247";
  --ag-icon-font-code-arrows: "\f0b2";
  --ag-icon-font-code-asc: "\f062";
  /* ... and so on - because --ag-icon-font-family sets the font for
     all icons, a new code must be provided for every one. If you only
     wanted to replace some icons, use --ag-icon-font-family-{icon-name} */

  /* selectively replace the group icon with one from Material Design Icons */
  --ag-icon-font-family-group: "Material Design Icons";
  --ag-icon-font-code-group: "\F0328";
  --ag-icon-font-color-group: red;
  --ag-icon-font-weight-group: normal;
}
```

#### Alternative Icon Font

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import "ag-grid-community/styles/agGridMaterialFont.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  Theme,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 170 },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      filter: true,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle} className="ag-theme-quartz">
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            theme={"legacy"}
            defaultColDef={defaultColDef}
            sideBar={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Alternative Icon Font](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-alternative-font/reactFunctionalTs/)

### Example: SVG icons

This example demonstrates using the `--ag-icon-image-icon-name` variables to set SVG images for specific icons.

```css
.ag-theme-quartz {
  /* hide all font icons */
  --ag-icon-font-display: none;
  /* provide a SVG icon */
  --ag-icon-image-aggregation: url("https://www.ag-grid.com/example-assets/svg-icons/aggregation.svg");
  --ag-icon-image-arrows: url("https://www.ag-grid.com/example-assets/svg-icons/arrows.svg");
  --ag-icon-image-asc: url("https://www.ag-grid.com/example-assets/svg-icons/asc.svg");
  /* ... and so on - because --ag-icon-font-display: none; hides all
     icons, an image must be provided for every one. If you only wanted
     to replace some icons, use --ag-icon-font-display-{icon-name} */
}
```

The following example replaces the grid's icons with SVG images:

#### SVG Icons

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  SideBarDef,
  TextEditorModule,
  Theme,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  IntegratedChartsModule,
  PivotModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  IntegratedChartsModule.with(AgChartsEnterpriseModule),
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  PivotModule,
  SetFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 170 },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      filter: true,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle} className="ag-theme-quartz">
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            theme={"legacy"}
            defaultColDef={defaultColDef}
            sideBar={true}
            enableCharts={true}
            cellSelection={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: SVG Icons](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-images/reactFunctionalTs/)

## Set the Icons Through gridOptions (JavaScript)

You can pass an `icons` property either on the [Grid Options](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-options/) to apply across the whole grid, or the [Column Definition](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-properties/). If both are provided, icons specified at the column level will take priority.

The `icons` property takes an object of name/value pairs where the name is one of the icon names below (note that these are different from the CSS names above) and the value is one of:

- An HTML string to be inserted in place of the usual DOM element for an icon
- A function that returns either an HTML string or a DOM node

#### Icon Grid Options

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  Icons,
  ModuleRegistry,
  NumberFilterModule,
  RowDragModule,
  SideBarDef,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  FiltersToolPanelModule,
  PivotModule,
  SideBarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  RowDragModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  FiltersToolPanelModule,
  PivotModule,
  SideBarModule,
  ColumnMenuModule,
  ContextMenuModule,
];

const myIcons = {
  sortAscending: () => {
    return "ASC";
  },
  sortDescending: () => {
    return "DESC";
  },
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      rowGroup: true,
      hide: true,
    },
    {
      field: "age",
      width: 90,
      enableValue: true,
      icons: {
        // not very useful, but demonstrates you can just have strings
        sortAscending: "U",
        sortDescending: "D",
      },
    },
    {
      field: "country",
      width: 150,
      rowGroupIndex: 0,
      icons: {
        sortAscending: '<i class="fa fa-sort-alpha-up"/>',
        sortDescending: '<i class="fa fa-sort-alpha-down"/>',
      },
    },
    { field: "year", width: 90, enableRowGroup: true },
    { field: "date" },
    {
      field: "sport",
      width: 110,
      icons: myIcons,
    },
    { field: "gold", width: 100 },
    { field: "silver", width: 100 },
    { field: "bronze", width: 100 },
    { field: "total", width: 100 },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 150,
      filter: true,
      floatingFilter: true,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      headerName: "Athlete",
      field: "athlete",
      rowDrag: true,
      // use font awesome for first col, with numbers for sort
      icons: {
        menu: '<i class="fa fa-shower"/>',
        menuAlt: '<i class="fa fa-shower"/>',
        filter: '<i class="fa fa-long-arrow-alt-up"/>',
        columns: '<i class="fa fa-snowflake"/>',
        sortAscending: '<i class="fa fa-sort-alpha-up"/>',
        sortDescending: '<i class="fa fa-sort-alpha-down"/>',
      },
      width: 300,
    };
  }, []);
  const icons = useMemo<Icons>(() => {
    return {
      // use font awesome for menu icons
      menu: '<i class="fa fa-bath" style="width: 10px"/>',
      menuAlt: '<i class="fa fa-bath" style="width: 10px"/>',
      filter: '<i class="fa fa-long-arrow-alt-down"/>',
      columns: '<i class="fa fa-handshake"/>',
      sortAscending: '<i class="fa fa-long-arrow-alt-down"/>',
      sortDescending: '<i class="fa fa-long-arrow-alt-up"/>',
      // use some strings from group
      groupExpanded:
        '<img src="https://www.ag-grid.com/example-assets/group/contract.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
      groupContracted:
        '<img src="https://www.ag-grid.com/example-assets/group/expand.png" style="height: 12px; width: 12px;padding-right: 2px"/>',
      columnMovePin: '<i class="far fa-hand-rock"/>',
      columnMoveAdd: '<i class="fa fa-plus-square"/>',
      columnMoveHide: '<i class="fa fa-times"/>',
      columnMoveMove: '<i class="fa fa-link"/>',
      columnMoveLeft: '<i class="fa fa-arrow-left"/>',
      columnMoveRight: '<i class="fa fa-arrow-right"/>',
      columnMoveGroup: '<i class="fa fa-users"/>',
      rowGroupPanel: '<i class="fa fa-university"/>',
      pivotPanel: '<i class="fa fa-magic"/>',
      valuePanel: '<i class="fa fa-magnet"/>',
      menuPin: "P", // just showing letters, no graphic
      menuValue: "V",
      menuAddRowGroup: "A",
      menuRemoveRowGroup: "R",
      clipboardCopy: ">>",
      clipboardCut: "<<",
      clipboardPaste: ">>",
      rowDrag: '<i class="fa fa-circle"/>',
      columnDrag: '<i class="fa fa-square"/>',
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            sideBar={true}
            autoGroupColumnDef={autoGroupColumnDef}
            icons={icons}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Icon Grid Options](https://www.ag-grid.com/archive/36.2.0/examples/theming-v32-custom-icons/icons-grid-options/reactFunctionalTs/)

In the following list, the name to use in the grid options is to the left, and on the right is the CSS icon name as listed in the [Provided Icons](https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-v32-custom-icons/#provided-icons) table below.

```js
// header column group shown when expanded (click to contract)
columnGroupOpened: 'expanded'
// header column group shown when contracted (click to expand)
columnGroupClosed: 'contracted'
// column tool panel column group contracted (click to expand)
columnSelectClosed: 'tree-closed',
// column tool panel column group expanded (click to contract)
columnSelectOpen: 'tree-open',
// column tool panel header expand/collapse all button, shown when some children are expanded and
//     others are collapsed
columnSelectIndeterminate: 'tree-indeterminate',
// accordion open (filter tool panel group, charts group)
accordionOpen: 'tree-open',
// accordion closed (filter tool panel group, charts group)
accordionClosed: 'tree-closed',
// accordion indeterminate - shown when some children are expanded and
//     others are collapsed (filter tool panel group, charts group)
accordionIndeterminate: 'tree-indeterminate',
// shown on drag and drop image component icon while dragging column to the side of the grid to pin
columnMovePin: 'pin'
// shown on drag and drop image component icon while dragging over part of the page that is not a drop zone
columnMoveHide: 'eye-slash'
// shown on drag and drop image component icon while dragging columns to reorder
columnMoveMove: 'arrows'
// animating icon shown when dragging a column to the right of the grid causes horizontal scrolling
columnMoveLeft: 'left'
// animating icon shown when dragging a column to the left of the grid causes horizontal scrolling
columnMoveRight: 'right'
// shown on drag and drop image component icon while dragging over Row Groups drop zone
columnMoveGroup: 'group'
// shown on drag and drop image component icon while dragging over Values drop zone
columnMoveValue: 'aggregation'
// shown on drag and drop image component icon while dragging over pivot drop zone
columnMovePivot: 'pivot'
// shown on drag and drop image component icon while dragging over drop zone that doesn't support it, e.g.
//     string column over aggregation drop zone
dropNotAllowed: 'not-allowed'
// shown on row group when contracted (click to expand)
groupContracted: 'tree-closed'
// shown on row group when expanded (click to contract)
groupExpanded: 'tree-open'
// set filter tree list group contracted (click to expand)
setFilterGroupClosed: 'tree-closed',
// set filter tree list group expanded (click to contract)
setFilterGroupOpen: 'tree-open',
// set filter tree list expand/collapse all button, shown when some children are expanded and
//     others are collapsed
setFilterGroupIndeterminate: 'tree-indeterminate',
// set filter async values loading
setFilterLoading: 'loading'
// context menu chart item
chart: 'chart'
// dialog title bar
close: 'cross'
// X (remove) on column 'pill' after adding it to a drop zone list
cancel: 'cancel'
// indicates the currently active pin state in the "Pin column" sub-menu of the column menu
check: 'tick'
// "go to first" button in pagination controls
first: 'first'
// "go to previous" button in pagination controls
previous: 'previous'
// "go to next" button in pagination controls
next: 'next'
// "go to last" button in pagination controls
last: 'last'
// shown on top right of chart when chart is linked to range data (click to unlink)
linked: 'linked'
// shown on top right of chart when chart is not linked to range data (click to link)
unlinked: 'unlinked'
// rotating spinner shown by the loading cell renderer
groupLoading: 'loading'
// button to launch legacy column menu
menu: 'menu',
// button to launch new enterprise column menu
menuAlt: 'menu-alt',
// menu tab icon in legacy tabbed enterprise column menu
legacyMenu: 'menu'
// open filter button - header, floating filter, menu
filter: 'filter',
// filter is applied - header (legacy column menu), filter tool panel
filterActive: 'filter'
// filter tab icon in legacy tabbed enterprise column menu
filterTab: 'filter',
// filter tool panel tab
filtersToolPanel: 'filter'
// columns in menu (column chooser / columns tab)
columns: 'columns'
// column tool panel tab
columnsToolPanel: 'columns'
// "Add Calculated Column" item in column header menu
calculatedColumnAdd: 'plus'
// "Edit Calculated Column" item in column header menu
calculatedColumnEdit: 'edit'
// "Remove Calculated Column" item in menus
calculatedColumnRemove: 'minus'
// "Edit Column Name" item in menus
columnHeaderEdit: 'edit'
// button in chart regular size window title bar (click to maximise)
maximize: 'maximize'
// button in chart maximised window title bar (click to make regular size)
minimize: 'minimize'
// "Pin column" item in column header menu
menuPin: 'pin'
// "Value aggregation" column menu item (shown on numeric columns when grouping is active)"
menuValue: 'aggregation'
// "Group by {column-name}" item in column header menu
menuAddRowGroup: 'group'
// "Un-Group by {column-name}" item in column header menu
menuRemoveRowGroup: 'group'
// context menu copy item
clipboardCopy: 'copy'
// context menu cut item
clipboardCut: 'cut'
// context menu paste item
clipboardPaste: 'paste'
// identifies the pivot drop zone
pivotPanel: 'pivot'
// "Row groups" drop zone in column tool panel
rowGroupPanel: 'group'
// columns tool panel Values drop zone
valuePanel: 'aggregation'
// drag handle used to pick up draggable columns
columnDrag: 'grip'
// drag handle used to pick up draggable rows
rowDrag: 'grip'
// context menu export item
save: 'save'
// csv export
csvExport: 'csv'
// excel export
excelExport: 'excel'
// icon on select dropdowns (select cell editor, charts tool panels)
selectOpen: 'small-down',
// open icon for rich select editor
richSelectOpen: 'small-down',
// remove for rich select editor pills
richSelectRemove: 'cancel',
// icon for sub menu item
subMenuOpen: 'small-right',
// version of subMenuOpen used in RTL mode
subMenuOpenRtl: 'small-left',
// separator between column 'pills' when you add multiple columns to the header drop zone
panelDelimiter: 'small-right',
// version of panelDelimiter used in RTL mode
panelDelimiterRtl: 'small-left',
// show on column header when column is sorted ascending
sortAscending: 'asc'
// show on column header when column is sorted descending
sortDescending: 'desc'
// show on column header when column has no sort, only when enabled with colDef.unSortIcon=true
sortUnSort: 'none',
// Builder button in Advanced Filter
advancedFilterBuilder: 'group',
// drag handle used to pick up Advanced Filter Builder rows
advancedFilterBuilderDrag: 'grip',
// Advanced Filter Builder row validation error
advancedFilterBuilderInvalid: 'not-allowed',
// shown on Advanced Filter Builder rows to move them up
advancedFilterBuilderMoveUp: 'up',
// shown on Advanced Filter Builder rows to move them down
advancedFilterBuilderMoveDown: 'down',
// shown on Advanced Filter Builder rows to add new rows
advancedFilterBuilderAdd: 'plus',
// shown on Advanced Filter Builder rows to remove row
advancedFilterBuilderRemove: 'minus',
// shown on Advanced Filter Builder selection pills
advancedFilterBuilderSelect: 'small-down',
// icon to open charts menu
chartsMenu: 'menu-alt',
// Edit Chart menu item shown in Integrated Charts menu
chartsMenuEdit: 'chart',
// Advanced Settings menu item shown in Integrated Charts menu
chartsMenuAdvancedSettings: 'settings',
// shown in Integrated Charts menu add fields
chartsMenuAdd: 'plus',
// shown in Integrated Charts tool panel color picker
chartsColorPicker: 'small-down'
// previous in Integrated Charts settings tool panel theme switcher
chartsThemePrevious: 'previous',
// next in Integrated Charts settings tool panel theme switcher
chartsThemeNext: 'next',
// download chart
chartsDownload: 'save',
```

## Provided Icons

Below you can see a list with all available icons for each provided theme. The name next to each icon is the CSS name, e.g. the `pin` icon will have the CSS class `ag-icon-pin` and uses the CSS variable `--ag-icon-font-code-pin`.

Available icons: `aggregation`, `arrows`, `asc`, `aasc`, `adesc`, `cancel`, `chart`, `chevron-up`, `chevron-down`, `chevron-left`, `chevron-right`, `color-picker`, `columns`, `contracted`, `copy`, `cut`, `cross`, `csv`, `desc`, `document`, `down`, `edit`, `excel`, `expanded`, `eye-slash`, `eye`, `filter`, `filter-add`, `first`, `fx`, `grip`, `group`, `last`, `left`, `linked`, `loading`, `maximize`, `menu`, `menu-alt`, `minimize`, `minus`, `next`, `none`, `not-allowed`, `paste`, `pin`, `pinned-bottom`, `pinned-top`, `pivot`, `plus`, `previous`, `right`, `save`, `search`, `small-down`, `small-left`, `small-right`, `small-up`, `tick`, `tree-closed`, `tree-indeterminate`, `tree-open`, `unlinked`, `up`, `values-as`

Download icon sets: [Quartz](https://www.ag-grid.com/archive/36.2.0/theme-icons/quartz/quartz-icons.zip), [Balham](https://www.ag-grid.com/archive/36.2.0/theme-icons/balham/balham-icons.zip), [Material](https://www.ag-grid.com/archive/36.2.0/theme-icons/material/material-icons.zip), [Alpine](https://www.ag-grid.com/archive/36.2.0/theme-icons/alpine/alpine-icons.zip)
